--
-- Copyright (C) 2022 Jonathan Certes
--
-- This program is free software: you can redistribute it and/or modify it under
-- the terms of the GNU General Public License as published by the Free Software
-- Foundation, either version 3 of the License, or (at your option) any later
-- version.
--
-- This program is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
-- details.
--
-- You should have received a copy of the GNU General Public License along with
-- this program. If not, see <http://www.gnu.org/licenses/>.
--

library ieee;
  use ieee.std_logic_1164.all;
  use ieee.std_logic_arith.all;
  use ieee.std_logic_unsigned.all;

entity up_counter is
  port(
    clk     : in  std_logic;
    reset   : in  std_logic;
    counter : out std_logic_vector(3 downto 0)
  );
end up_counter;

architecture bhv of up_counter is
  signal counter_up : std_logic_vector(3 downto 0) := "0000";
begin
  process(clk, reset)
  begin
    if ( reset = '1' ) then
      counter_up <= (others => '0');
    elsif ( rising_edge(clk) ) then
      counter_up <= counter_up + 1;
    end if;
  end process;
  counter <= counter_up;
end bhv;
