--
-- Copyright (C) 2022 Jonathan Certes
--
-- This program is free software: you can redistribute it and/or modify it under
-- the terms of the GNU General Public License as published by the Free Software
-- Foundation, either version 3 of the License, or (at your option) any later
-- version.
--
-- This program is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
-- details.
--
-- You should have received a copy of the GNU General Public License along with
-- this program. If not, see <http://www.gnu.org/licenses/>.
--

library ieee;
  use ieee.std_logic_1164.all;
  use work.all;

entity testbench is
end testbench;

architecture bhv of testbench is
  signal clk     : std_logic := '0';
  signal reset   : std_logic := '0';
  signal counter : std_logic_vector(3 downto 0);
begin
  default clock is rising_edge(clk);  -- definition of PSL next()

  -- PSL:
  psl_end_count   : assert eventually!(counter = "1111");
  psl_start_count : assert always((counter = "0000") -> next(counter = "0001"));

  DUT : entity up_counter(bhv)
  port map (
    clk     => clk,
    reset   => reset,
    counter => counter
  );

  process begin
    clk <= '0';
    wait for 10 ns;
    clk <= '1';
    wait for 10 ns;
  end process;

  process begin
    wait for 365 ns;
    reset <= '1';
    wait; -- forever
  end process;
end bhv;
